#include <States/GameState/Maze/Room/Room.h>

Room::Room(float size) : m_rectangle({size, size}) {
    m_rectangle.setOrigin(size/2, size/2);
}

void Room::set_side(const Direction side, const std::shared_ptr<IRoomSide>& ptr_side) {
    if (side == INVALID) throw std::invalid_argument("Invalid direction");
    m_sides[side] = ptr_side;
    m_sides[side]->prepare_for_drawing();
}

Room::Direction Room::get_direction(const IRoomSide* ptr_side) const {
    if (m_sides[LEFT].get() == ptr_side) return LEFT;
    if (m_sides[RIGHT].get() == ptr_side) return RIGHT;
    if (m_sides[UP].get() == ptr_side) return UP;
    if (m_sides[DOWN].get() == ptr_side) return DOWN;
    return INVALID;
}

void Room::draw_into(sf::RenderWindow& window) const {
    window.draw(m_rectangle);
    for (auto& side : m_sides) {
        side->draw_into(window);
    }
}
