#pragma once
#include <BasicAbstractions/IPreparable.h>

class IEntity;
class Room;

struct IRoomSide : IPreparable {
    virtual void enter(IEntity* entity) const = 0;
    ~IRoomSide() override = default;
};

class Pass final : public IRoomSide {
public:
    explicit Pass(Room& room1, Room& room2) : m_room1(room1), m_room2(room2) {}
    void enter(IEntity* entity) const override;
    void draw_into(sf::RenderWindow& window) const override {}
    void prepare_for_drawing() override {}
private:
    Room& m_room1;
    Room& m_room2;
};

class Wall final : public IRoomSide {
public:
    explicit Wall(Room& room) : m_room(room) {}
    void enter(IEntity* entity) const override {}
    void draw_into(sf::RenderWindow& window) const override { window.draw(m_line, 2, sf::Lines); }
    void prepare_for_drawing() override;
private:
    Room& m_room;
    sf::Vertex m_line[2];
};